/*
 * Voorbeeld DriveInfo
 * 
 * Dit bestand mag alleen gebruikt worden voor opleidingen die
 * georganiseerd worden door Beta VZW
 * (C) Beta VZW 2009
 */

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace UsingDriveInfo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DriveInfo[] di = DriveInfo.GetDrives();
            foreach(DriveInfo drive in di)
            {
                lbDrives.Items.Add(drive.Name);
            }
        }

        private void lbDrives_SelectedIndexChanged(object sender, EventArgs e)
        {
            DriveInfo di = new DriveInfo(lbDrives.SelectedItem.ToString());
            try
            {
                MessageBox.Show(
                    "Available Free Space available to current user: " + di.AvailableFreeSpace + "bytes\n" +
                    "Drive Format: " + di.DriveFormat + "\n" +
                    "Total Size: " + di.TotalSize + "bytes\n" +
                    "Volume label: " + di.VolumeLabel,
                    di.Name);
            }
            catch (IOException)
            {
                MessageBox.Show("exception during querying drive");
            }
        }
    }
}