/*
 * Voorbeeld FileStream, BinaryWriter, BinaryReader
 * 
 * Dit bestand mag alleen gebruikt worden voor opleidingen die
 * georganiseerd worden door Beta VZW
 * (C) Beta VZW 2009
 */

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

namespace Bestand03
{
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox txtGrootte;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label lblSchrijven;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label lblLezen;
		private System.Windows.Forms.Button btnLezenSchrijven;

		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
		}


		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtGrootte = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.lblSchrijven = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.lblLezen = new System.Windows.Forms.Label();
			this.btnLezenSchrijven = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// txtGrootte
			// 
			this.txtGrootte.Location = new System.Drawing.Point(88, 16);
			this.txtGrootte.Name = "txtGrootte";
			this.txtGrootte.TabIndex = 0;
			this.txtGrootte.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 23);
			this.label1.TabIndex = 1;
			this.label1.Text = "Grootte";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 48);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(72, 23);
			this.label2.TabIndex = 2;
			this.label2.Text = "Schrijftijd";
			// 
			// lblSchrijven
			// 
			this.lblSchrijven.Location = new System.Drawing.Point(88, 48);
			this.lblSchrijven.Name = "lblSchrijven";
			this.lblSchrijven.TabIndex = 3;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 80);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(56, 23);
			this.label4.TabIndex = 4;
			this.label4.Text = "Leestijd";
			// 
			// lblLezen
			// 
			this.lblLezen.Location = new System.Drawing.Point(88, 80);
			this.lblLezen.Name = "lblLezen";
			this.lblLezen.TabIndex = 5;
			// 
			// btnLezenSchrijven
			// 
			this.btnLezenSchrijven.Location = new System.Drawing.Point(208, 16);
			this.btnLezenSchrijven.Name = "btnLezenSchrijven";
			this.btnLezenSchrijven.Size = new System.Drawing.Size(75, 40);
			this.btnLezenSchrijven.TabIndex = 6;
			this.btnLezenSchrijven.Text = "Schrijven en lezen";
			this.btnLezenSchrijven.Click += new System.EventHandler(this.btnLezenSchrijven_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(328, 141);
			this.Controls.Add(this.btnLezenSchrijven);
			this.Controls.Add(this.lblLezen);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.lblSchrijven);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.txtGrootte);
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btnLezenSchrijven_Click(object sender, System.EventArgs e)
		{
			Cursor.Current = Cursors.WaitCursor;
			const string bestandsnaam = @"C:\temp\data.bin";
			//opm: we veronderstellen dat map c:\temp bestaat
			Int32 bestandsgrootte = Convert.ToInt32(txtGrootte.Text);
			using(FileStream fs = new FileStream(bestandsnaam,FileMode.OpenOrCreate))
			{
				fs.SetLength(0);
				BinaryWriter bw = new BinaryWriter(fs);
//				bw.BaseStream.Seek(0,SeekOrigin.Begin);
				int beginWrite = Environment.TickCount;
				for (int i=0;i<bestandsgrootte;i++)
				{
					bw.Write((byte)i);
				}
				fs.Flush();
				int eindWrite = Environment.TickCount;
				lblSchrijven.Text = ((eindWrite - beginWrite)/1000).ToString() + " seconden";
				BinaryReader br = new BinaryReader(fs);
				br.BaseStream.Seek(0,SeekOrigin.Begin);
				int beginRead = Environment.TickCount;
				for (int i=0;i<bestandsgrootte;i++)
				{
					br.ReadByte();
				}
				fs.Flush();
				int eindRead = Environment.TickCount;
				lblLezen.Text = ((eindRead - beginRead)/1000).ToString()+" seconden";
			}
			File.Delete(bestandsnaam);			
			Cursor.Current = Cursors.Default;
		}
	}
}
