/*
 * Voorbeeld serialisatie
 * 
 * Dit bestand mag alleen gebruikt worden voor opleidingen die
 * georganiseerd worden door Beta VZW
 * (C) Beta VZW 2009
 */

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;

namespace Serialisatie01
{
    public partial class Form1 : Form
    {
        private IList<Persoon> personen = new List<Persoon>();
        public Form1()
        {
            InitializeComponent();
            persoonBindingSource.DataSource = personen;
        }

        private BinaryFormatter formatter = new BinaryFormatter();
        private void btnOpenen_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                String filename = openFileDialog1.FileName;
                using (FileStream bestand = new FileStream(filename,FileMode.Open))
                {
                    personen = (IList<Persoon>)formatter.Deserialize(bestand);
                    persoonBindingSource.DataSource = personen;
                }
            }
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                String filename = saveFileDialog1.FileName;
                using (FileStream bestand = new FileStream(filename,FileMode.CreateNew))
                {
                    formatter.Serialize(bestand, personen);
                }
            }
        }
    }
}