/*
 * Voorbeeld serialisatie
 * 
 * Dit bestand mag alleen gebruikt worden voor opleidingen die
 * georganiseerd worden door Beta VZW
 * (C) Beta VZW 2009
 */

using System;
using System.Collections.Generic;
using System.Text;

namespace Serialisatie01
{
    [Serializable]
    public class Persoon:IComparable<Persoon>
    {
        private String naam="";

        public String Naam
        {
            get { return naam; }
            set { naam = value; }
        }
        private DateTime geboorteDatum;

        public DateTime GeboorteDatum
        {
            get { return geboorteDatum; }
            set { geboorteDatum = value; }
        }
        public override bool Equals(object obj)
        {
            if (obj == null) return false;
            Persoon p = obj as Persoon;
            if (p == null) return false;
            return naam.Equals(p.Naam) && geboorteDatum.Equals(p.GeboorteDatum);
        }
        public override int GetHashCode()
        {
            return String.Format("{0}{1:d}",naam, geboorteDatum).GetHashCode();
        }
        public override string ToString()
        {
            return naam;
        }

        #region IComparable<Persoon> Members

        public int CompareTo(Persoon other)
        {
            if (other == null) return 1;
            if (other.Naam == Naam) return geboorteDatum.CompareTo(other.geboorteDatum);
            return Naam.CompareTo(other.Naam);

        }

        #endregion
    }
}
