/*
 * Voorbeeld StreamReader, StreamWriter (syll. p. 95)
 * 
 * Dit bestand mag alleen gebruikt worden voor opleidingen die
 * georganiseerd worden door Beta VZW
 * (C) Beta VZW 2009
 */

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;  /// for StreamReader and StreamWriter

namespace TextFiles
{
    public class Form1 : System.Windows.Forms.Form
    {
        #region Windows Form Designer generated code
        private System.Windows.Forms.Button btnRead;
        private System.Windows.Forms.Button btnWrite;
        private System.Windows.Forms.TextBox txtContents;
        private System.ComponentModel.Container components = null;

        public Form1()
        {
            InitializeComponent();
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }


        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.btnRead = new System.Windows.Forms.Button();
            this.btnWrite = new System.Windows.Forms.Button();
            this.txtContents = new System.Windows.Forms.TextBox();
            this.SuspendLayout();
            // 
            // btnRead
            // 
            this.btnRead.Location = new System.Drawing.Point(48, 16);
            this.btnRead.Name = "btnRead";
            this.btnRead.TabIndex = 0;
            this.btnRead.Text = "Read";
            this.btnRead.Click += new System.EventHandler(this.btnRead_Click);
            // 
            // btnWrite
            // 
            this.btnWrite.Location = new System.Drawing.Point(160, 16);
            this.btnWrite.Name = "btnWrite";
            this.btnWrite.TabIndex = 1;
            this.btnWrite.Text = "Write";
            this.btnWrite.Click += new System.EventHandler(this.btnWrite_Click);
            // 
            // txtContents
            // 
            this.txtContents.Location = new System.Drawing.Point(8, 56);
            this.txtContents.Multiline = true;
            this.txtContents.Name = "txtContents";
            this.txtContents.Size = new System.Drawing.Size(272, 208);
            this.txtContents.TabIndex = 2;
            this.txtContents.Text = "";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(292, 273);
            this.Controls.Add(this.txtContents);
            this.Controls.Add(this.btnWrite);
            this.Controls.Add(this.btnRead);
            this.Name = "Form1";
            this.Text = "Reading and writing text files";
            this.ResumeLayout(false);

        }

        [STAThread]
        static void Main()
        {
            Application.Run(new Form1());
        }

        #endregion

        private void btnRead_Click(object sender, System.EventArgs e)
        {
            OpenFileDialog fd = new OpenFileDialog();
            if (fd.ShowDialog() != DialogResult.Cancel)
            {
                if (File.Exists(fd.FileName))
                {
                    string line;
                    StreamReader file = null;
                    txtContents.Clear();

                    try
                    {
                        // read file and display it line by line
                        file = new StreamReader(fd.FileName);
                        // or: 
                        // file = File.OpenText(fd.FileName);
                        while ((line = file.ReadLine()) != null)
                        {
                            txtContents.Text += line + System.Environment.NewLine;
                        }
                    }
                    catch (IOException)
                    {
                        MessageBox.Show("error: file does not exists");
                    }
                    finally
                    {
                        if (file != null)
                            file.Close();
                    }
                }
            }
        }

        private void btnWrite_Click(object sender, System.EventArgs e)
        {
            SaveFileDialog fd = new SaveFileDialog();
            if (fd.ShowDialog() != DialogResult.Cancel)
            {
                StreamWriter file = null;

                try
                {
                    // create new file, or overwrite existing file:
                    file = new StreamWriter(fd.FileName);
                    // or: 
                    // file = File.CreateText(fd.FileName);

                    // to append an existing file, use:
                    // file = new StreamWriter(fd.FileName, true);

                    // write line by line to file
                    for (int i = 0; i < txtContents.Lines.Length; i++)
                    {
                        file.WriteLine(txtContents.Lines[i]);
                    }
                }
                catch (PathTooLongException)
                {
                    MessageBox.Show("error: path name too long");
                }
                catch (IOException)
                {
                    MessageBox.Show("error: disk full ?? read-only file ??");
                }
                finally
                {
                    if (file != null)
                        file.Close();
                }
            }
        }
    }
}
