using System;
using System.Collections;

// non-generic versie
public class CSharpCursussen //: IEnumerable
// sinds C# 2.0 volstaat het dat en klasse een methode GetEnumerator
// heeft die een IEnumerator teruggeeft om
// een object van deze klasse te kunnen overlopen met
// een foreach-lus
{
    private string[] cursussen = { "Overzicht .net", "Inleiding C#", "Vervolmaking C#", "ADO.net", "XML en C#"};

    // definitie van een iterator
    public IEnumerator GetEnumerator()
    {
        for (int i = 0; i < cursussen.Length; i++)
        {
            yield return cursussen[i];
        }
    }
}

class TestCSharpCursussen
{
    static void Main()
    {
        CSharpCursussen cursussen = new CSharpCursussen();

        // overloop met foreach
        foreach (string cursus in cursussen)
        // impliciete oproep van cursussen.GetEnumerator()
        {
            System.Console.WriteLine( cursus );
        }
    }
}