﻿using System;
using System.Collections.Generic;
using System.Text;

// generic versie
public class GenericCSharpCursussen : IEnumerable<string>
// sinds C# 2.0 volstaat het dat en klasse een methode GetEnumerator()
// heeft die een IEnumerator teruggeeft om
// een object van deze klasse te kunnen overlopen met
// een foreach-lus
{
    private string[] cursussen = { "Overzicht .net", "Inleiding C#", "Vervolmaking C#", "ADO.net", "XML en C#" };

    #region IEnumerable Members

    // definitie van een iterator
    public IEnumerator<string> GetEnumerator()
    {
        for (int i = 0; i < cursussen.Length; i++)
        {
            yield return cursussen[i];
        }
    }

    System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
    {
        return this.GetEnumerator();
    }
    
    #endregion
}

class TestGenericCSharpCursussen
{
    static void Main()
    {
        GenericCSharpCursussen cursussen = new GenericCSharpCursussen();

        // overloop met foreach
        foreach (string cursus in cursussen)
        // impliciete oproep van cursussen.GetEnumerator()
        {
            System.Console.WriteLine(cursus);
        }
    }
}
