﻿/*
 * Voorbeeld LINQ  (syll. p. 85 -86)
 * 
 * Dit bestand mag alleen gebruikt worden voor opleidingen die
 * georganiseerd worden door Beta VZW
 * (C) Beta VZW 2009
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace vbLINQ
{
    class Program
    {
        static void Main(string[] args)
        {
            List<String> matrozen = new List<String>();
            matrozen.AddRange(new String[]{"Jan", "Piet", "Joris", "Korneel"});
            var namenMetJ = from s in matrozen // gegevensbron
                            where s.StartsWith("J") // filter
                            orderby s descending // sortering
                            select s.ToUpper(); // gewenste output
            matrozen.Add("Juul");
            matrozen.Add("Stien");
            foreach (String matroos in namenMetJ) // eigenlijke opvraging
            {
                Console.WriteLine(matroos);
            }

            Console.WriteLine();

            int aantalNamenMetJ = namenMetJ.Count();
            Console.WriteLine("Er zijn {0} matrozennamen die beginnen met een 'J'", aantalNamenMetJ);

            Console.WriteLine();

            // groeperingen
            var frequentiePerBeginLetter = from s in matrozen
                                           group s by s[0] into groep // groeperen per beginletter
                                           select new { BeginLetter = groep.Key, Aantal = groep.Count()};
            foreach(var item in frequentiePerBeginLetter)
            {
                Console.WriteLine("{0} namen beginnen met de letter {1}",
                    item.Aantal, item.BeginLetter);
            }
        }
    }
}
