﻿/*
 * Voorbeeld van IComparable
 * Zie syllabus p. 77-78
 * 
 * Dit bestand mag alleen gebruikt worden voor opleidingen die
 * georganiseerd worden door Beta VZW
 * (C) Beta VZW 2009
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace sets
{
    public class Student : IComparable<Student>
    {
        private String naam;
        private int leerjaar;
        public Student(String aNaam, int aLeerjaar)
        {
            naam = aNaam;
            leerjaar = aLeerjaar;
        }
        public override string ToString()
        {
            return leerjaar + " " + naam;
        }
        public override bool Equals(object obj)
        {
            if (obj == null) return false;
            Student other = obj as Student;
            if (other == null) return false;
            return naam == other.naam && leerjaar == other.leerjaar;
        }
        public override int GetHashCode()
        {
            int hash = 27;
            hash = (13 * hash) + naam.GetHashCode();
            hash = (13 * hash) + leerjaar;
            return hash;
        }
        #region IComparable<Student> Members

        public int CompareTo(Student other)
        {
            if (other == null) return 1;
            if (leerjaar < other.leerjaar) return -1;
            else
            {
                if (leerjaar == other.leerjaar)
                {
                    return naam.CompareTo(other.naam);
                }
                else
                {
                    return 1;
                }
            }
        }

        #endregion
    }

}
