/* 
 * Dit bestand mag alleen gebruikt worden voor opleidingen die
 * georganiseerd worden door Beta VZW
 * (C) Beta VZW 2009
 */

using System;

namespace ExceptiesEigen
{
	/// <summary>
	/// Voorbeeld eigen excepties creren: in plaats van de 
	/// bestaande ArgumentOutOfRangeException, gebruiken we 
	/// nu de eigen BuitenDeWeekException, die specifiek voor 
	/// NaamVanDag optreedt. Zo kan ArgumentOutOfRangeException
	/// specifiek optreden wanneer er een te grote integer 
	/// wordt ingevoerd.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		static void Main(string[] args)
		{
			try
			{
				string vandaag = NaamVanDag(21);
			}
			catch(BuitenDeWeekException e)
			{
				Console.WriteLine("fout : " + e.Message);
			}
			Console.WriteLine("Na het catch gedeelte");
	
		}
		static string NaamVanDag(int dag)
		{
			switch(dag)
			{
				case 0: return "zondag";
				case 1: return "maandag";
				case 2: return "dinsdag";
				case 3: return "woensdag";
				case 4: return "donderdag";
				case 5: return "vrijdag";
				case 6: return "zaterdag";
				default: throw new BuitenDeWeekException("slechte dag");
			}
		}
	}
    //
    //Gegenereerd via "Exception" code snippet
    //
    [Serializable]
    public class BuitenDeWeekException : Exception
    {
        public BuitenDeWeekException() { }
        public BuitenDeWeekException(string message) : base(message) { }
        public BuitenDeWeekException(string message, Exception inner) : base(message, inner) { }
        protected BuitenDeWeekException(
          System.Runtime.Serialization.SerializationInfo info,
          System.Runtime.Serialization.StreamingContext context)
            : base(info, context) { }
    }

}
