﻿/*
 * Voorbeeld van een BankRekening klasse met Constructor overloading
 * (pag 14-16 in de syllabus)
 * Dit bestand mag alleen gebruikt worden voor opleidingen die
 * georganiseerd worden door Beta VZW
 * (C) Beta VZW 2009
 */
using System;
using System.Collections.Generic;
using System.Text;

namespace vbbank02
{
    public class BankRekening
    {
        private decimal saldo;
        private string naam;
        #region zonder aanroep van andere constructors in dezelfde klasse
        //public BankRekening()
        //{
        //    naam = "onbekend";
        //}
        //public BankRekening(String naam)
        //{
        //    this.naam = naam;
        //}
        //public BankRekening(decimal saldo, String naam)
        //{
        //    this.saldo = saldo;
        //    this.naam = naam;
        //}
        #endregion
        #region met aanroep van andere constructors
        public BankRekening()
            : this("onbekend")
        {
        }
        public BankRekening(String naam): this(0, naam)
        {
        }
        public BankRekening(decimal saldo, String naam)
        {
            this.saldo = saldo;
            this.naam = naam;
        }
        #endregion
        public void StortGeld(decimal saldo)
        {
            this.saldo = this.saldo + saldo;
        }
        public void HaalGeldAf(decimal saldo)
        {
            this.saldo = this.saldo - saldo;
        }
        public decimal GeefSaldo()
        {
            return this.saldo;
        }
        public String GeefNaam()
        {
            return this.naam;
        }
        // destructor (p. 16)
        ~BankRekening()
        {
            Console.WriteLine("Dit wordt uitgevoerd net voordat de garbage collector het object opruimt");
        }
    }
}
