/*
 * Voorbeeld delegates (syll. p. 39-40)
 * 
 * Dit bestand mag alleen gebruikt worden voor opleidingen die
 * georganiseerd worden door Beta VZW
 * (C) Beta VZW 2009
 */

using System;

namespace Delegates
{
	/// <summary>
	/// Voorbeeld Delegates: In de klasse Calculaties worden
	/// er drie methoden gedefinieerd. Met de delegate DelegBereken
	/// kunnen deze methoden uitgevoerd worden. Dit gebeurd in
	/// de methode ToonResultaat, waarbij de delegate als parameter
	/// wordt meegegeven. 
	/// </summary>
    /// 
    // definitie delegate
	delegate double DelegBereken(double Getal1, double Getal2);

	class Calculaties 
	{
		public double Vermenigvuldigen(double getal1 , double getal2)
		{
			Console.WriteLine("Vermenigvuldigen");
			return getal1 * getal2;
		}
		public  double Optellen(double getal1 , double getal2)
		{
			Console.WriteLine("Optellen");
			return getal1 + getal2;
		}
		public  double Delen(double getal1 , double getal2)
		{
			Console.WriteLine("Delen");
			return getal1 - getal2;
		}

	}

	class TestKlasse 
	{
		public static void Main()
		{
			Calculaties cal = new Calculaties();
			DelegBereken delegBerek = cal.Vermenigvuldigen;
			ToonResultaat(delegBerek,8.5,6);
			delegBerek = Math.Pow;
			ToonResultaat(delegBerek,8.5,6);

            ToonResultaat(delegate(double getal1, double getal2)
                    { return 4 * getal1 + getal2; }, 1,2);
		}


        // gebruik delegate
		public static void ToonResultaat(DelegBereken aDelegBereken,
			double getal1, double getal2)
		{
			//Deze methode hoeft niet te weten welke bewerking of
			//functie uitgevoerd dient te worden.
			Console.WriteLine("Het resultaat is : "+ aDelegBereken(getal1,
				getal2));
		}
	}
}
