﻿/*
 *
 * Dit bestand mag alleen gebruikt worden voor opleidingen die
 * georganiseerd worden door Beta VZW
 * (C) Beta VZW 2009
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace vbevent
{
    // 1. definitie delegate
    public delegate void DelegVerwittig();

    // klasse die events afvuurt
    public class BankRekening
    {
        private decimal saldo;

        // 2. definitie event
        public event DelegVerwittig Negatief;
        public event DelegVerwittig Positief;

        public decimal Saldo
        {
            get { return saldo; }
        }
        public void Storten(decimal bedrag)
        {
            saldo += bedrag;
            if (saldo < 0) OnNegatief();
            if (saldo > 0) OnPositief();
        }
        public void Afhalen(decimal bedrag)
        {
            Storten(-bedrag);
        }

        // 3. definitie hulpmethode 
        private void OnNegatief()
        {
            // 4. afvuren event
            if (Negatief != null) Negatief();
        }
        private void OnPositief()
        {
            if (Positief != null) Positief();
        }
    }
}
