/*
 * 
 *  Dit voorbeeld mag alleen gebruikt worden in de opleidingen van Beta VZW 
 * (C) Beta VZW, 2009
 */
using System;
using System.Collections.Generic;
using System.Text;

namespace vbindexer
{
    public class Woordenboek
    {
        private Verklaring[] lijst;
        private const int MAX_VERKLARING = 1000;
        private int teller = 0;
        public Woordenboek()
        {
            lijst = new Verklaring[MAX_VERKLARING];
        }
        public void VoegVerklaringToe(string term, string def)
        {
            if (teller < MAX_VERKLARING)
            {
                Verklaring v = new Verklaring(term, def);
                lijst[teller] = v;
                teller++;
            }
        }
        public string VraagVerklaring(string term)
        {
            int i = 0;
            while (i < teller && term.ToLower() != lijst[i].Term.ToLower())
            {
                i++;
            }
            if (i < teller)
            {
                return lijst[i].Definitie;
            }
            else
            {
                return "Term niet gevonden";
            }
        }
        public string this[string term]
        {
            get{return VraagVerklaring(term);}
            set { VoegVerklaringToe(term, value); }
        }
        
    }
    public class Verklaring
    {
        private string term;

        public string Term
        {
            get { return term; }
            set { term = value; }
        }
        private string definitie;

        public string Definitie
        {
            get { return definitie; }
            set { definitie = value; }
        }
        public Verklaring(String term, String definitie)
        {
            this.term = term;
            this.definitie = definitie;
        }
    }
}
