/*
 * Voorbeeld van inheritance en het oproepen van de constructor van de basisklasse
 * zie syllabus p 29-30
 * 
 * Dit voorbeeld mag alleen gebruikt worden tijdens de opleidingen van Beta VZW
 * (C) Beta VZW, 2009
 */ 
using System;
using System.Collections.Generic;
using System.Text;

namespace vbinherit01
{
    public class Persoon
    {
        private String naam;
        public String Naam
        {
            get { return naam; }
            //protected set { naam = value; }
        }
        #region lege constructor voor Persoon
        //protected Persoon()
        //{
        //}
        #endregion
        public Persoon(String naam)
        {
            this.naam = naam;
            Console.WriteLine("In de constructor van Persoon");
        }
        ~Persoon()
        {
            Console.WriteLine("In de destructor van Persoon");
        }
    }
    public class Werknemer : Persoon
    {
        private decimal loon;
        public decimal Loon
        {
            get { return loon; }
        }
        //
        // Deze constructor roept de Persoon(String) constructor op
        // Omdat de Naam-property read only is en de naam member variabele private
        // is dit de enige manier om de naam van een werknemer in te vullen.
        //
        public Werknemer(String naam, decimal loon)
            : base(naam)
        {
            this.loon = loon;
            Console.WriteLine("In de constructor van Werknemer");
        }
        #region alternatief met protected setter in Persoon
        //om deze constructor te kunnen gebruiken moet
        // 1) de protected property Naam uit commentaar gehaald worden
        // 2) er een lege constructor worden aangemaakt voor Persoon
        //public Werknemer(String naam, decimal loon)
        //{
        //    this.Naam = naam; //protected property
        //    this.loon = loon;
        //}
        #endregion
        ~Werknemer()
        {
            Console.WriteLine("In de destructor van Werknemer");
        }
        //
        // Deze constructor roept de lege constructor op van de basisklasse
        // (die niet gedefinieerd is) 
        //
        //public Werknemer(decimal loon)
        //{
        //    this.loon = loon;
        //}
    }
}
