﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;


namespace vbBackgroundWorker
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            backgroundWorker1.WorkerReportsProgress = true;
            backgroundWorker1.WorkerSupportsCancellation = true;
            listBox1.DataSource = bindingSource1;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                String folder = folderBrowserDialog1.SelectedPath;
                btnCancel.Enabled = true;
                btnStart.Enabled = false;
                bindingSource1.Clear();
                backgroundWorker1.RunWorkerAsync(folder);
            }
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            List<String> lijst = new List<string>();
            DirectoryInfo info = new DirectoryInfo((String)e.Argument);
            int i = 0;
            FileInfo[] files = info.GetFiles();
            int lengte = files.Length;
            foreach (FileInfo fi in files)
            {
                lijst.Add(fi.Name);
                backgroundWorker1.ReportProgress((int)((++i / (double) lengte)*100));
                System.Threading.Thread.Sleep(1000);
                if (backgroundWorker1.CancellationPending)
                {
                    e.Cancel = true;
                    return;
                }
            }

            e.Result = lijst;
        }

        private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            if (e.Cancelled)
            {
                MessageBox.Show("Onderbroken");
            }
            else
            {
                List<String> l = (List<String>)e.Result;
                //listBox1.DataSource = l;
                bindingSource1.DataSource = l;
            }
            btnCancel.Enabled = false;
            btnStart.Enabled = true;
            progressBar1.Value = 0;
        }

        private void backgroundWorker1_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            progressBar1.Value = e.ProgressPercentage;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            backgroundWorker1.CancelAsync();
        }
    }

}

