/*
 * Werken met threads
 * 
 * Dit bestand mag alleen gebruikt worden voor opleidingen die
 * georganiseerd worden door Beta VZW
 * (C) Beta VZW 2009
 */

//#define WAITFORTHREADS
//#define PRIORITY

using System;
using System.Threading;

namespace threadTester
{  
   class ThreadTester
   {
      static void Main( string[] args )
      {
         // Maak drie threads en geef hen een naam
         // Geef de Print methode mee als argument van ThreadStart delegate.
         MessagePrinter printer1 = new MessagePrinter();
         Thread thread1 = 
  //          new Thread ( new ThreadStart( printer1.Print ) );
            new Thread(printer1.Print);
         thread1.Name = "thread1";

         MessagePrinter printer2 = new MessagePrinter();
         Thread thread2 = 
//            new Thread ( new ThreadStart( printer2.Print ) );
            new Thread(printer2.Print);
         thread2.Name = "thread2";

#if PRIORITY
		thread2.Priority = ThreadPriority.Highest;
		Console.WriteLine("Thread2 krijgt de hoogste prioriteit");
#endif

         MessagePrinter printer3 = new MessagePrinter();
         Thread thread3 = 
//            new Thread ( new ThreadStart( printer3.Print  ) );
            new Thread(printer3.Print);
         thread3.Name = "thread3";
#if PRIORITY
		  thread3.Priority = ThreadPriority.Lowest;
		  Console.WriteLine("Thread3 krijgt de laagste prioriteit");
#endif

         Console.WriteLine( "Starting threads" );

         // Roep de Start method op van elke thread 
         // De threads zijn in Started Positie
         thread1.Start();
         thread2.Start();
         thread3.Start();
         Console.WriteLine( "Threads started\n" ); 

#if WAITFORTHREADS
	    Console.WriteLine("dmv Join wordt er gewacht door de thread Main");
		thread1.Join();
		thread2.Join();
		thread3.Join();
#endif
		Console.WriteLine( "Einde Main" ); 
	
      } // einde method Main

   } // einde class ThreadTester

   // De Print methode van deze klasse wordt uitgevoerd door de threads
   class MessagePrinter 
   {
      private int sleepTime;
      private static Random random = new Random();
      
      // constructor
      public MessagePrinter()
      {
         // Neem random sleep time tussen 0 and 5 seconde
#if PRIORITY
         sleepTime = 5000;
#else
		 sleepTime = random.Next( 5001 );
#endif
      }

      // methode Print controleert de threads
      public void Print() 
      {
         // Om de huidige thread op te vragen:
         Thread current = Thread.CurrentThread; 

         // Laat de thread slapen voor een bepaalde tijd
         Console.WriteLine( 
            current.Name + " slaapt voor " + sleepTime +" milliseconden." );

/*#if PRIORITY
		long counter=0;
		  while (counter<100000000L)
		  {
			  counter++;
		  }
#else*/
		  Thread.Sleep ( sleepTime );
//#endif

         // toon naam thread 
         Console.WriteLine( current.Name + " is wakker" );

      } // einde methode Print

   } // einde class MessagePrinter
}


