﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace vberrorprovidertooltip
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
            //Dialoogvenster moet een vaste grootte hebben
            FormBorderStyle = FormBorderStyle.FixedDialog;
            //Validation events mogen niet optreden wanneer we op Annuleren klikken
            btnAnnuleren.CausesValidation = false;
            btnAnnuleren.DialogResult = DialogResult.Cancel;
            //manuele validatie in OK knop
            //AutoValidate = AutoValidate.Disable;
            toolTip1.SetToolTip(txtCursus, "Tik hier de unieke cursuscode in");
        }
        //delegate die wordt uitgevoerd wanneer een control moet gevalideerd worden
        private void txtCursus_Validating(object sender, CancelEventArgs e)
        {
            if (((TextBox)sender).Text == "")
            {
                e.Cancel = true; //validatie is mislukt, resultaat hangt af van AutoValidate property van form
                errorProvider1.SetError((Control)sender, "U moet een code invullen");
            }
        }
        //delegate die wordt uitgevoerd wanneer de control gevalideerd is
        private void txtCursus_Validated(object sender, EventArgs e)
        {
            errorProvider1.SetError((Control)sender, null);
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            //automatische validatie (form.AutoValidate=AutoValidate.EnablePreventFocusChange)
            DialogResult = DialogResult.OK;
            //manuele validatie
            //if (ValidateChildren())
            //{
            //    DialogResult = DialogResult.OK;
            //}
        }
    }
}
